#ifndef SKILLDETAILSTREEWIDGET_H
#define SKILLDETAILSTREEWIDGET_H

#include <QTreeWidget>

#include "RobotAPI/libraries/skills_gui/aron_tree_widget/AronTreeWidgetController.h"

#include "../memory/MemoryCommunicatorBase.h"

namespace armarx::skills::gui
{
    class SkillDetailsTreeWidget : public QTreeWidget, public MemoryCommunicatorBase
    {
        Q_OBJECT
    public:
        SkillDetailsTreeWidget(std::shared_ptr<SkillManagerWrapper> _memory,
                               QWidget* parent = nullptr);

        std::optional<skills::SkillID> getShownId();
        void updateContents(skills::SkillID const& skillId, skills::SkillDescription const& descr);

        aron::data::DictPtr getConfigAsAron();
        void copyCurrentConfig();
        void pasteCurrentConfig();
        void resetCurrentConfig();

        void resetWidget();

    public slots:
        void disconnectGui();
        void updateGui();
        void resizeContents();

    private:
        struct ShownSkill
        {
            skills::SkillID skillId;
            skills::SkillDescription descr;
        };

        std::optional<ShownSkill> shownSkill;

        // The size, which we assume the last column to be.
        // If the last column has too little space, increase this value.
        const int typeWidth = 200;

        AronTreeWidgetControllerPtr aronTreeWidgetController = nullptr;
        void setupUi();
    };
} // namespace armarx::skills::gui

#endif // SKILLDETAILSTREEWIDGET_H
